package base

import (
	"git.fsdpf.net/go/contracts"
)

type ResQueryExtend struct {
	Uuid         string         `db:"uuid"`
	Category     int64          `db:"category"`      // 类型, 0=排序,1=分组
	CategoryUuid string         `db:"category_uuid"` // 所属UUID
	Type         string         `db:"type"`          // 表达式类型. sql/field
	Expr         string         `db:"expr"`          // 表达式
	Extra        map[string]any `db:"extra"`         // 扩展配置
	Serial       int64          `db:"serial"`        // 权重
	UpdatedAt    string         `db:"updated_at"`
	CreatedAt    string         `db:"created_at"`
}

type GetResQueryExtends func(categoryUuid string, category int64) []ResQueryExtend
type GetOrderByResQueryExtends func(items ...ResQueryExtend) contracts.OrderBy
type GetGroupByResQueryExtends func(items ...ResQueryExtend) contracts.GroupBy
